#include <stdio.h>
#include <string.h>
#define SSH_PORT 20

char broadcastPckt[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff};


int analysePacket(unsigned char *packet, int len){
	int ret=-1;
	if(strncmp((char *)packet, broadcastPckt, sizeof(broadcastPckt))==0){
		fprintf(stdout, "broadcast packet\n");
		return 5;
	}

	else if(packet[12]==0x08 && packet[13]==0x00 ){ //to make sure we read IPv4 header not other headers (ie: VLAN)

		if(packet[23]==0x01){//ICMP
#ifdef DEBUG
			printf("ping\n");
#endif
			return 0;
		}
		else{
			if((packet[26]==10) || ((packet[26]==172) && ((packet[27]>=16) && (packet[27]<32))) || ((packet[26]==192) && (packet[27]==168))){
#ifdef DEBUG
				printf("private IP address ");
#endif
				ret=6;
			}
			
			else{
#ifdef DEBUG
				printf("public IP address ");
#endif
				ret=7;
			}
#ifdef DEBUG				
			printf("%u.%u.%u.%u : ", packet[26], packet[27], packet[28], packet[29]);
#endif

			if(packet[36]==0 ){
				if(packet[37]==80){//destination port 80 :::HTTP
#ifdef DEBUG
					printf("-> HTTP\n");
#endif
					return 1;
				}
				else if(packet[37]==53){
#ifdef DEBUG
					printf("-> DNS\n");//DNS query
#endif
					return 2;
				}

				else if(packet[37]==SSH_PORT){
#ifdef DEBUG
					printf("-> SSH/SFTP\n");
#endif
					return 3;
				}

			}

			else if((packet[36]==0x01) && (packet[37]==0xBB)){
#ifdef DEBUG
					printf("-> HTTPS\n");
#endif
					return 1;
			}

			else if((packet[36]==0x04) && (packet[37]==0x01)){
#ifdef DEBUG
					printf("-> NFS\n");
#endif
					return 4;
			}			
			printf("\n");
			return ret; //only information available : public or private IP address
		}

	}
	return -1; //unknown packet
		

}
