#include <gtk/gtk.h> 
#include <string.h>
#include "gtk.h"
#include "packet.h"

GtkWidget *window;
GtkWidget *button, *volume, *toggle_button;
GtkLabel *bcastlabel, *icmplabel, *dnslabel, *nfslabel;
GtkLabel *httplabel, *sshlabel, *unknownlabel;
gWidgets widgets[8];
int play=0;
extern int loop;
extern int nbThread;
extern int vol;
packetList packet;
void getObjectFromFile(GtkBuilder *gtkBuilder){//build gtk widgets from file
	int i;
	
	gchar *data[8]={	"checkbutton1", "checkbutton2", "checkbutton3", 
				"checkbutton4", "checkbutton5", "checkbutton6",
				"checkbutton7", "checkbutton8"	};
	gtk_builder_add_from_file(gtkBuilder, "builder.ui", NULL);
	window = GTK_WIDGET(gtk_builder_get_object(gtkBuilder, "window"));

	for(i=0;i<8; i++){
		widgets[i].checkbox = GTK_WIDGET(gtk_builder_get_object(gtkBuilder, data[i]));
		widgets[i].id = i;
		g_signal_connect(widgets[i].checkbox, "clicked", G_CALLBACK(toggle_checkbox), (gpointer)(widgets+i));
	}

	volume = GTK_WIDGET(gtk_builder_get_object(gtkBuilder, "volumebutton1"));
	g_signal_connect (volume, "released", G_CALLBACK (getVolume), NULL);

	bcastlabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_bcast"));
	icmplabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_icmp"));
	dnslabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_dns"));
	nfslabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_nfs"));
	httplabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_http"));
	sshlabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_ssh"));
	unknownlabel = GTK_LABEL(gtk_builder_get_object(gtkBuilder, "label_unknown"));

	toggle_button = GTK_WIDGET(gtk_builder_get_object(gtkBuilder, "playbutton"));
	g_signal_connect (toggle_button, "toggled", G_CALLBACK (toggled), NULL);

	button = GTK_WIDGET(gtk_builder_get_object(gtkBuilder, "quitbutton"));
	g_signal_connect (button, "clicked", G_CALLBACK (quit), NULL);
}
void quit(GtkWidget *widget, gpointer data){
	gint i;
	gtk_widget_destroy(window);
	/*for(i=0;i<9; i++)
		gtk_widget_unrealize(widgets[i].checkbox);
	gtk_widget_unrealize(toggle_button);
	gtk_widget_unrealize(volume);
	gtk_widget_unrealize(button);
	gtk_widget_unrealize(window);*/

	for(i=0;i<8; i++)
		gtk_widget_destroyed(widgets[i].checkbox, &widgets[i].checkbox);
	gtk_widget_destroyed(toggle_button, &toggle_button);
	gtk_widget_destroyed(volume, &volume);
	gtk_widget_destroyed(button, &button);
	

	//gtk_widget_unrealize(window);
	
	/*for(i=0;i<9; i++)
		gtk_widget_unrealize(widgets[i].checkbox);*/

	
	gtk_widget_destroyed(window, &window);
	loop=0;
	while(nbThread>0){
		g_print("Thread count : %d\n", nbThread);
		usleep(500000);
	}
	gtk_main_quit();	
}

void changeLabel(GtkLabel *label, int value){
	char buffer[4];
	sprintf(buffer, "%d", value);
	gtk_label_set_text (label, buffer);
}

void printLabel(GtkWidget *widget, gpointer data){	
	changeLabel(bcastlabel, packet.broadcast);
	changeLabel(icmplabel, packet.icmp);	
	changeLabel(dnslabel, packet.dns);
	changeLabel(nfslabel, packet.nfs);
	changeLabel(httplabel, packet.http);
	changeLabel(sshlabel, packet.ssh_sftp);
	changeLabel(unknownlabel, packet.unknown);
	
	
}

void toggled(GtkWidget *widget, gpointer data){
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget))) {		
		g_print("play\n");
		play=1;
	} 
	else{	
		g_print("stop\n");
		play=0;		
	}
}


void getCheckBox(guint id, guint enable){
#ifdef DEBUG
	switch(id){
		case 0: 
			printf("ICMP");
			break;
		case 1: 
			printf("HTTP(S)");
			break;
		case 2: 
			printf("DNS");
			break;
		
		case 3: 
			printf("SSH/SFTP");
			break;		
		
		case 4: 
			printf("NFS");
			break;
		case 5: 
			printf("Broadcast");			
			break;
		case 6: 
			printf("Private IP");
			break;
		case 7: 
			printf("Public IP");
			break;
	}
	if(enable) g_print(" checked\n");
	else g_print(" unchecked\n");
#endif

	packet.enable[id]=enable;
}

void toggle_checkbox(GtkWidget *widget, gpointer window){
	gWidgets *obj;
	obj=(gWidgets *)window;
	if (gtk_toggle_button_get_active(GTK_TOGGLE_BUTTON(widget)))
		getCheckBox(obj->id, 1);
		
	else
		getCheckBox(obj->id, 0);

}

void getVolume(GtkWidget *button, gpointer data){
	vol=(int)(gtk_scale_button_get_value(GTK_SCALE_BUTTON(button))*100);
	g_print("Volume is set to %d%%\n",vol);
}
