#include <stdio.h>
#include <string.h>
#include "packet.h"
#define SSH_PORT 20

char broadcastPckt[]={0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
extern packetList packet;

int analysePacket(unsigned char *packetArg, int len){
	int ret=-1;
	if(strncmp((char *)packetArg, broadcastPckt, sizeof(broadcastPckt))==0){
		fprintf(stdout, "broadcast packet\n");
		if(packet.enable[5])
			packet.broadcast++;
		return 5;
	}

	else if(packetArg[12]==0x08 && packetArg[13]==0x00 ){ //to make sure we read IPv4 header not other headers (ie: VLAN)

		if(packetArg[23]==0x01){//ICMP
#ifdef DEBUG
			printf("ping\n");
#endif
			if(packet.enable[0])
				packet.icmp++;
			return 0;
		}
		else{
			if((packetArg[26]==10) || ((packetArg[26]==172) && ((packetArg[27]>=16) && (packetArg[27]<32))) || ((packetArg[26]==192) && (packetArg[27]==168))){
#ifdef DEBUG
				printf("private IP address ");
#endif
				ret=6;
			}
			
			else{
#ifdef DEBUG
				printf("public IP address ");
#endif
				ret=7;
			}
#ifdef DEBUG				
			printf("%u.%u.%u.%u : ", packetArg[26], packetArg[27], packetArg[28], packetArg[29]);
#endif

			if(packetArg[36]==0 ){
				if(packetArg[37]==80){//destination port 80 :::HTTP
#ifdef DEBUG
					printf("-> HTTP\n");
#endif
					if(packet.enable[1])
						packet.http++;
					return 1;
				}
				else if(packetArg[37]==53){
#ifdef DEBUG
					printf("-> DNS\n");//DNS query
#endif
					if(packet.enable[2])
						packet.dns++;
					return 2;
				}

				else if(packetArg[37]==SSH_PORT){
#ifdef DEBUG
					printf("-> SSH/SFTP\n");
#endif
					if(packet.enable[3])
						packet.ssh_sftp++;
					return 3;
				}

			}

			else if((packetArg[36]==0x01) && (packetArg[37]==0xBB)){
#ifdef DEBUG
					printf("-> HTTPS\n");
#endif
					if(packet.enable[1])
						packet.http++;
					return 1;
			}

			else if((packetArg[36]==0x04) && (packetArg[37]==0x01)){
#ifdef DEBUG
					printf("-> NFS\n");
#endif
					if(packet.enable[4])
						packet.nfs++;
					return 4;
			}			
			printf("\n");
			packet.unknown++;
			return ret; //only information available : public or private IP address
		}

	}
	packet.unknown++;
	return -1; //unknown packet
		

}
